<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_CAT_MIXTURE_ID',
					'PARAM_CAT_MIXTURE_BASE_CAT_PRODUCT_ID',
					'PARAM_CAT_MIXTURE_ING_CAT_PRODUCT_ID',
					'PARAM_CAT_MIXTURE_QUANTITY_FROM',
					'PARAM_CAT_MIXTURE_QUANTITY_TO',
					'PARAM_CAT_MIXTURE_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_CAT_MIXTURE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_MIXTURE_ID');
			$PARAM_CAT_MIXTURE_BASE_CAT_PRODUCT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_MIXTURE_BASE_CAT_PRODUCT_ID');
			$PARAM_CAT_MIXTURE_ING_CAT_PRODUCT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_MIXTURE_ING_CAT_PRODUCT_ID');
			$PARAM_CAT_MIXTURE_QUANTITY_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_CAT_MIXTURE_QUANTITY_FROM');
			$PARAM_CAT_MIXTURE_QUANTITY_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_CAT_MIXTURE_QUANTITY_TO');
			$PARAM_CAT_MIXTURE_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_MIXTURE_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'CAT_MIXTURE_ID', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID', 
						'CAT_MIXTURE_QUANTITY', 
						'CAT_MIXTURE_STATUS'
						, 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_ID', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_CAT_UOM_ID', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_BARCODE', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_ITEMCODE', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_DESCRIPTION', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_HAS_RECIPE', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_ING_PRICE', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_ING_NET_CONTENT', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_MIXTURE_QTY', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_STATUS', 
						'CAT_MIXTURE_BASE_CAT_PRODUCT_ID_CAT_PRODUCT_SYSTEM_GENERATED', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_ID', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_CAT_UOM_ID', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_BARCODE', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_ITEMCODE', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_DESCRIPTION', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_HAS_RECIPE', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_ING_PRICE', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_ING_NET_CONTENT', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_MIXTURE_QTY', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_STATUS', 
						'CAT_MIXTURE_ING_CAT_PRODUCT_ID_CAT_PRODUCT_SYSTEM_GENERATED'
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_CATEGORY_MIXTURE::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_CAT_MIXTURE_ID'] = $PARAM_CAT_MIXTURE_ID;
			$GET_MAP_ARRAY['PARAM_CAT_MIXTURE_BASE_CAT_PRODUCT_ID'] = $PARAM_CAT_MIXTURE_BASE_CAT_PRODUCT_ID;
			$GET_MAP_ARRAY['PARAM_CAT_MIXTURE_ING_CAT_PRODUCT_ID'] = $PARAM_CAT_MIXTURE_ING_CAT_PRODUCT_ID;
			$GET_MAP_ARRAY['PARAM_CAT_MIXTURE_QUANTITY_FROM'] = $PARAM_CAT_MIXTURE_QUANTITY_FROM;
			$GET_MAP_ARRAY['PARAM_CAT_MIXTURE_QUANTITY_TO'] = $PARAM_CAT_MIXTURE_QUANTITY_TO;
			$GET_MAP_ARRAY['PARAM_CAT_MIXTURE_STATUS'] = $PARAM_CAT_MIXTURE_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_CATEGORY_MIXTURE::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>